#include <randomnumber.h>
#include <stdlib.h>
#include <config.h>

#if defined(HAVE_SRAND48) && defined(HAVE_LRAND48)
	#define SEEDRANDOM srand48
	#define GETRANDOM lrand48
#elif defined(HAVE_SRAND) && defined(HAVE_RAND)
	#define SEEDRANDOM srand
	#define GETRANDOM rand
#else
	#error "Couldn't find a suitable replacement for srand48/lrand48"
#endif

randomnumber::randomnumber() {
	seed=0;
	number=0;
}

randomnumber::~randomnumber() {
}

void	randomnumber::setSeed(int seed) {
	this->seed=seed;
	SEEDRANDOM(seed);
}

int	randomnumber::getSeed() {
	return seed;
}

int	randomnumber::generateNumber() {
	this->number=GETRANDOM();
	return this->number;
}

int	randomnumber::getNumber() {
	return this->number;
}

int	randomnumber::getScaledNumber(int lower, int upper) {

	float	shiftedupper=(float)upper-(float)lower+1.0;

	int	num=1+(int)(shiftedupper*(float)number/(RAND_MAX+1.0));

	return num+lower-1;
}
