// Copyright (c) 1999-2000 David Muse
// See the COPYING file for more information

#include <config.h>

#include <stdio.h>
#include <sys/types.h>
#if defined(HAVE__USR_LOCAL_FIRSTWORKS_INCLUDE_REGEX_H)
	#include "/usr/local/firstworks/include/regex.h"
#elif defined(HAVE__FIRSTWORKS_INCLUDE_REGEX_H)
	#include "/firstworks/include/regex.h"
#elif defined(HAVE_REGEX_H)
	#include <regex.h>
#elif defined(HAVE_REGEXP_H)
	#include <regexp.h>
#elif defined(HAVE_LIBGEN_H)
	#include <libgen.h>
#elif defined(HAVE_REGEXPR_H)
	#include <regexpr.h>
#endif

#include <regularexpression.h>

regularexpression::regularexpression() {
}

regularexpression::~regularexpression() {
}

int	regularexpression::match(char *str, char *pattern) {

	int	retval=0;

	#if defined(HAVE_REGEX_H) || defined(HAVE__USR_LOCAL_FIRSTWORKS_INCLUDE_REGEX_H) || defined(HAVE__FIRSTWORKS_INCLUDE_REGEX_H)
		regex_t	preg;

		if (!regcomp(&preg,pattern,REG_EXTENDED|REG_NOSUB)) {
			retval=!regexec(&preg,str,0,
					(regmatch_t *)NULL,0);
		}
		regfree(&preg);
	#elif defined(HAVE_REGEXP_H)
		regexp *prog=regcomp(pattern);

		if (prog) {
			retval=regexec(prog,str);
		}
		delete prog;
	#elif defined(HAVE_REGCMP)
		char	*re=regcmp(pattern,NULL);
		if (re && regex(re,str,NULL)) {
			retval=1;
		}
		delete re;
	#elif defined(HAVE_RE_COMP)
		re_comp(pattern);
		if (!re_exec(str)) {
			retval=1;
		}
	#elif defined(HAVE_REGEXPR_H)
		char	*expbuf=compile(pattern,NULL,NULL);
		if (expbuf && step(str,expbuf)) {
			retval=1;
		}
	#endif

	return retval;
}
